$(".alert-dismissible").fadeOut(0);
var table;

$(document).ready(function () 
{
    table = $('#datatable-fixedheader').DataTable({
        retrieve: true,
        columnDefs: [],
        "processing": true,
        "serverSide": true,
        "lengthChange": true,
        "ordering": true,
        'autoWidth': false,
        "pagingType": "full_numbers",
        "iDisplayLength": 10,
        "lengthMenu": [
            [10, 25, 50, -1],
            [10, 25, 50, "All"]
        ],
        "order": [],  
        "ajax": {
            "url": BASEURL + 'eventcategory-list',
            "type": "POST"
        },
       
        "columnDefs": [{
            "targets": [0, 3, 5], 
            "orderable": false,             
        }],

        "fnInitComplete": function () 
        { 
            $(".dt-container .dt-search").append('<button type="button" id="cb-add" class="btn btn-secondary waves-effect waves-light" data-bs-toggle="modal" data-bs-target=".modal1" onclick="add_data()">+ Add New</button>');
        },
    });
});

function reload_table() 
{
    table.ajax.reload(null, false);  
}

$('.modal').on('shown.bs.modal', function () {
    $('[name="cat_name"]').focus();
});

var save_method;

function add_data() 
{
    save_method = 'add';
    $('#id').val(''); 
     
    $('#form').parsley().reset();
    $('#form')[0].reset();
    $(".modal-title").html('Add Image Category');
    $('#submit').attr('disabled', false);    
    $("#submit").html('Save');     
}

function edit_data(id) 
{
    save_method = 'update';
    
    $('#form').parsley().reset();
    $('#form')[0].reset();
    $(".modal-title").html('Edit Image Category');
    $("#submit").html('Update');
    $('#submit').attr('disabled', false);
    $('.modal1').modal('show');    

    $.ajax({
        url: BASEURL + 'eventcategory/edit/' + id,
        type: "GET",
        dataType: "JSON",
        success: function (data) {
            $('[name="id"]').val(data.id);
            $('[name="cat_name"]').val(data.cat_name); 
            $('[name="sequence_no"]').val(data.sequence_no);  
        },
        error: function (jqXHR, textStatus, errorThrown) {
            alert('Error! Get data from database.');
        }
    });
} 
 
function deactive(id) 
{
    $.ajax({
        type: "POST",
        url: BASEURL + 'eventcategory/deactive/' + id,
        data: {id: id},
        dataType: "json",
        success: function (data) {
            if (data == 'sucess') {
                reload_table();
            } else {
                alert('Status Update Fail');
            }
        }
    });
}

function active(id) 
{
    $.ajax({
        type: "POST",
        url: BASEURL + 'eventcategory/active/' + id,
        data: {id: id},
        dataType: "json",
        success: function (data) {
            if (data == 'sucess') {
                reload_table();
            } else {
                alert('Status Update Fail');
            }
        }
    });
}

$(document).on("click", ".delete_btn", function (event) {
    var id = $(this).attr('data-id');  
    
    Swal.fire({
        title: "Are you sure?",
        text: "You won't be able to revert this!",
        icon: "warning",
        showCancelButton: true,
        confirmButtonColor: "#34c38f",
        cancelButtonColor: "#f03b3b",
        confirmButtonText: "Yes, delete it!",
        cancelButtonText: "No, cancel!"
    }).then(function (result) {
        if (result.value) {
            $.ajax({
                type: 'POST',
                url: BASEURL + 'eventcategory/delete/' + id,
                data: {id: id},
                dataType: 'json',
                beforeSend: function () {
                    $('.dataTables_processing').css('visibility', 'visible');
                },
                success: function (returnData) {
                    if (returnData.status == 'ok') {
                        Swal.fire({
                            title: "Deleted!",
                            text: "Record has been deleted.",
                            icon: "success"
                        });
                        reload_table();
                    } else if (returnData.status == 'not') {
                        Swal.fire({
                            title: "Cancelled",
                            text: "Record can't delete, Because they are used in " + returnData.tbc_name + ".",
                            icon: "error"
                        });
                    }
                },
                complete: function () {
                    $('.dataTables_processing').css('visibility', 'hidden');
                },
                error: function() {
                    Swal.fire({
                        title: "Error!",
                        text: "Something went wrong!",
                        icon: "error"
                    });
                }
            });
        }
    });
}); 
 
$('#form').submit(function (e) {
    e.preventDefault();
    
    if ($('#form').parsley().isValid()) 
    { 
        $('#submit').attr('disabled', true);
        $("#submit").html('<i class="mdi mdi-loading mdi-spin"></i> Processing...');
        
        $.ajax({
            url: BASEURL + 'eventcategory/submit',
            type: "POST",
            data: new FormData(this),
            processData: false,
            contentType: false,
            cache: false,
            dataType: "JSON",
            success: function (result) 
            {
                if (result.status == 'ok') 
                {
                   
                    $('.modal1').modal('hide');
                    
                    
                    reload_table(); 
                    
                    
                    $('#id').val(''); 
                    $('#form').parsley().reset();
                    $('#form')[0].reset();
                    $('#submit').html('Save');
                    $('#submit').attr('disabled', false);
                    
                    
                    $(".alert-danger").hide();
                    $(".alert-success").show();
                    $(".alert-success-msg").html(result.message);                        
                    setTimeout(function () {
                        $(".alert-success").fadeOut(500);
                    }, 5000);
                } 
                else 
                {
                   
                    $('.modal1').modal('hide');
                    
                    
                    $('#id').val(''); 
                    $('#form').parsley().reset();
                    $('#form')[0].reset();
                    $('#submit').html('Save');
                    $('#submit').attr('disabled', false);
                    
                    
                    $(".alert-success").hide();
                    $(".alert-danger").show();
                    $(".alert-danger-msg").html(result.message);
                    setTimeout(function () {
                        $(".alert-danger").fadeOut(500);
                    }, 5000);
                }
            },
            error: function(xhr, status, error) {
                $('#submit').html('Save');
                $('#submit').attr('disabled', false);
                
                $('.modal1').modal('hide');
                
                alert('Error: ' + error);
            }
        });
    }
    
    return false;
});